/*
 * Created on 23/05/2006
 *
 * 
 * Window - Preferences - Java - Code Style - Code Templates
 */

package zb2smt;

import java.util.LinkedList;

import zb2smt.bol.BIdentifier;
import zb2smt.bol.Predicate;


/**
 * @author eberton
 * 
 * 
 * Preferences - Java - Code Style - Code Templates
 */
public class POLabel {
	String label;

	String header;
	
	LinkedList<BIdentifier> extrapreds_smt;
	
	LinkedList<BIdentifier> extrafuns_smt;
	
	LinkedList<Predicate> assumptions_smt;

	Predicate pOPredicate;

	public POLabel(String label, Predicate pOPredicate,LinkedList<BIdentifier> extrapreds_smt,LinkedList<BIdentifier> extrafuns_smt,LinkedList<Predicate> assumptions) {
		this.label = label;
		//this.header = header;
		this.pOPredicate = pOPredicate;
		this.extrapreds_smt = extrapreds_smt;
		this.extrafuns_smt = extrafuns_smt;
		this.assumptions_smt = assumptions;
	}


	public POLabel(String label, String header,
			Predicate pOPredicate,
			LinkedList<BIdentifier> extrapreds_smt,LinkedList<BIdentifier> extrafuns_smt,LinkedList<Predicate> assumptions) {
		this.label = label;
		this.header = header;
		this.pOPredicate = pOPredicate;
		this.extrapreds_smt = extrapreds_smt;
		this.extrafuns_smt = extrafuns_smt;
		this.assumptions_smt = assumptions;
	}
	
	public String getHeader() {
		return header;
	}

	public void setHeader(String header) {
		this.header = header;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public Predicate getPOPredicate() {
		return pOPredicate;
	}

	public void setPOPredicate(Predicate predicate) {
		pOPredicate = predicate;
	}

	public LinkedList<BIdentifier> getExtrapreds_smt() {
		if (this.extrapreds_smt == null) extrapreds_smt = new  LinkedList<BIdentifier>();
		return extrapreds_smt;
	}

	public void setExtrapreds_smt(LinkedList<BIdentifier> extrapreds_smt) {
		this.extrapreds_smt = extrapreds_smt;
	}

	public LinkedList<BIdentifier> getExtrafuns_smt() {
		if (this.extrafuns_smt == null) extrafuns_smt = new  LinkedList<BIdentifier>(); 
			return extrafuns_smt;
	}

	public void setExtrafuns_smt(LinkedList<BIdentifier> extrafuns_smt) {
		this.extrafuns_smt = extrafuns_smt;
	}


	public LinkedList<Predicate> getAssumptions() {
		if (this.assumptions_smt == null) this.assumptions_smt = new  LinkedList<Predicate>();
		return assumptions_smt;
	}


	public void setAssumptions(LinkedList<Predicate> assumptions) {
		this.assumptions_smt = assumptions;
	}


}
