package zb2smt;

import java.io.*;

public class SystemTermCommand{

		
	
	public SystemTermCommand(){
	}

	
	
	public static String callHarvey(String cmd) throws IOException{

		
		 Runtime runtime = Runtime.getRuntime();
		 Process proc = runtime.exec(cmd);
		
		
		// put a BufferedReader on the ls output
		InputStream inputstream = proc.getInputStream();
		InputStreamReader inputstreamreader = new InputStreamReader(inputstream);
		BufferedReader bufferedreader = new BufferedReader(inputstreamreader);

		// read the ls output
		String line;
		StringBuffer text_result= new StringBuffer();
		
		while ((line = bufferedreader.readLine()) != null) {
			text_result.append(line+"\n");
			//System.out.println(line);
		}
		
		// check for ls failure
		try {
			if (proc.waitFor() != 0) {
				System.err.println("exit value = " + proc.exitValue());
			}
		} catch (InterruptedException e) {
			System.err.println(e);
		}
		
		
		return text_result.substring(0);
	}
	
	
	
	/*
	 * public static void main(String[] args) throws IOException {
	 * 
	 * if (args.length != 1) { System.out.println("missing directory");
	 * 
	 * System.exit(1); }
	 * 
	 * 
	 * call_rv(args[0]);
	 *  }
	 */
	
	
	 static String execute_script(String path,String filename) {
		 
		 	StringBuffer text_result = new StringBuffer();
	        String res_line = null;
	        
  

	        try { 

	        	
	        	FileReader fr     = new FileReader(path+filename);
	        	BufferedReader br = new BufferedReader(fr);
	        	
	           res_line = new String();
	           while ((res_line = br.readLine()) != null) {
	        	       	   
	        	   	// Here is executed each command of script sh and add a path.
	        	    text_result.append(callHarvey(res_line.replaceAll(" "," "+path )) +"\n");
	        	   
	           } 

	        } catch (IOException e) { 
	           // catch possible io errors from readLine()
	           System.err.println("ERRO - The Batcave can't execute the harvey (SystemTermCommand)");

	           e.printStackTrace();
	        }
	        
	        
	        return text_result.substring(0);
	     } // end of execute_script()
	
	
}
