package zb2smt.bol;



public class Assert extends Substitution {
	Predicate predicate;

	Substitution substitution;

	public Assert() {
	}

	public void setFields(BObject[] values) {
		predicate = (Predicate) values[0];
		substitution = (Substitution) values[1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "ASSERT\n" + indent);
		predicate.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "THEN\n" + indent);
		substitution.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "END");
	}*/
	
	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}

	public boolean isFree(BIdentifier[] idents){
		return predicate.isFree(idents) && substitution.isFree(idents);
	}
	
	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}
}