package zb2smt.bol;

import zb2smt.IPOPrint;

public class BBoolean extends AtomicElement {
	public BBoolean() {
	}

	public void setFields(String value) {
		this.value = value;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(value);
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return value.equals(arg0.value);
	}

	public Expression cloneObject() {
		BBoolean bBooleanClone;
		bBooleanClone = new BBoolean();
		bBooleanClone.setFields(new String(value));
		return bBooleanClone;
	}

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exps) {
		return this;
	}*/

	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<idents.length;i++){
			if(idents[i].getValue().equals(getValue())){
				return false;
			}
		}
		return true;
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

}