package zb2smt.bol;

import zb2smt.IPOPrint;

public class BIdentifier extends AtomicElement {
	public BIdentifier() {
	}

	public void setFields(String value) {
		this.value = value;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(value);
	}*/

	public void afterDot(StringBuffer sb, String indent) {
		String tmp = new String(value);
		if (tmp.lastIndexOf('.') != -1) {
			sb = sb.append(tmp
					.substring(tmp.lastIndexOf('.') + 1, tmp.length()));
		} else {
			sb = sb.append(tmp);
		}
	}

	public String getName() {
		return new String(value);
	}

	public boolean findDependency(BIdentifier arg0) {
		return value.equals(arg0.value);
	}

	public Expression cloneObject() {

		BIdentifier bIdentifierClone;

		bIdentifierClone = new BIdentifier();
		bIdentifierClone.setFields(new String(value));

		return bIdentifierClone;

	}

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exps) {
		for (int i = identifiers.length - 1; i >= 0; i--) {
			if (this.value.equals(identifiers[i].value)) {
				return exps[i];
			}
		}

		return this;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

}
