package zb2smt.bol;

import zb2smt.IPOPrint;

public class BPreviousValue extends AtomicElement {
	BIdentifier identifier;

	public BPreviousValue() {
	}

	public void setFields(BObject[] values) {
		identifier = (BIdentifier) values[0];
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	/*public void toBString(StringBuffer sb, String indent) {
		identifier.toBString(sb, indent);
		sb.append("$0");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return value.equals(arg0.value);
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	public Expression cloneObject() {
		BPreviousValue bPreviousValueClone;
		BObject bObject[];
		bPreviousValueClone = new BPreviousValue();
		bObject = new BObject[1];
		bObject[0] = identifier.cloneObject();
		bPreviousValueClone.setFields(bObject);
		return bPreviousValueClone;
	}

	public BObject substitute(BIdentifier[] identifiers, Expression[] exps) {
		return this;
	} 
	
	public BIdentifier getIdentifier() {
		return identifier;
	}

	public void setIdentifier(BIdentifier identifier) {
		this.identifier = identifier;
	}
}