package zb2smt.bol;



public class BecomeEqualFunction extends Substitution {
	CallFunction callFunction;

	Expression expression;

	public BecomeEqualFunction() {
	}

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public void setFields(BObject[] values) {
		callFunction = (CallFunction) values[0];
		expression = (Expression) values[1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		callFunction.toBString(sb, indent);
		sb = sb.append(" := ");
		expression.toBString(sb, indent);
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return callFunction.isFree(idents) && expression.isFree(idents);
	}

	public CallFunction getCallFunction() {
		return callFunction;
	}

	public void setCallFunction(CallFunction callFunction) {
		this.callFunction = callFunction;
	}

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}