package zb2smt.bol;


public class BecomeSuch extends Substitution {
	BIdentifier[] identifiers;

	Predicate predicate;

	public BecomeSuch() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		predicate = (Predicate) values[values.length - 1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(" :: ");
		predicate.toBString(sb, indent);
	}*/

	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents);
	}
	
	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}
}