package zb2smt.bol;


public abstract class BinaryPredicate extends Predicate {
	Predicate left;
	Predicate right;

	public void setFields(BObject[] values) {
		left = (Predicate) values[0];
		right = (Predicate) values[1];
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}
	
	public Predicate getLeft() {
		return left;
	}

	public void setLeft(Predicate left) {
		this.left = left;
	}

	public Predicate getRight() {
		return right;
	}

	public void setRight(Predicate right) {
		this.right = right;
	}
}