package zb2smt.bol;

import zb2smt.IPOPrint;

public class BooleanSet extends SetExpression {
	public BooleanSet() {
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("BOOL");
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return false;
	}

	public Expression cloneObject() {
		return new BooleanSet();
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		return this;
	}*/

	public boolean isFree(BIdentifier[] idents){
		return true;
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

}