package zb2smt.bol;

import zb2smt.IPOPrint;

public class CallFunction extends SetFunction {
	Expression expression;

	Expression parametre;

	public CallFunction() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
		parametre = (Expression) values[1];
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public void toBString(StringBuffer sb, String indent) {
		expression.toBString(sb, indent);
		sb = sb.append("(");
		parametre.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents) && parametre.isFree(idents);
	}

	public boolean findDependency(BIdentifier bIdentifier) {
		return expression.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		CallFunction callFunctionClone = new CallFunction();
		callFunctionClone.expression = this.expression.cloneObject();
		callFunctionClone.parametre = this.parametre.cloneObject();
		return callFunctionClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		System.out.println("N� tratado-substitute-CallFunction");
		return this;
	}*/
	
	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}

	public Expression getParametre() {
		return parametre;
	}

	public void setParametre(Expression parametre) {
		this.parametre = parametre;
	}
}