package zb2smt.bol;


public class CallOperation extends Substitution {
	Results results;

	OperationName name;

	EffectiveParameters parameters;

	public CallOperation() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		if (i < values.length && (values[i] instanceof Results)) {
			results = (Results) values[i];
			i += 1;
		}
		name = (OperationName) values[i];
		i += 1;
		if (i < values.length && (values[i] instanceof EffectiveParameters)) {
			parameters = (EffectiveParameters) values[i];
			i += 1;
		}
	}
	
	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return results.isFree(idents) && name.isFree(idents) && parameters.isFree(idents) ;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		if (results != null) {
			results.toBString(sb, indent);
			sb.append("<--");
		}
		name.toBString(sb, indent);
		if (parameters != null) {
			sb = sb.append("(");
			parameters.toBString(sb, indent);
			sb = sb.append(")");
		}
	}*/

	public OperationName getName() {
		return name;
	}

	public void setName(OperationName name) {
		this.name = name;
	}

	public EffectiveParameters getParameters() {
		return parameters;
	}

	public void setParameters(EffectiveParameters parameters) {
		this.parameters = parameters;
	}

	public Results getResults() {
		return results;
	}

	public void setResults(Results results) {
		this.results = results;
	}
}