package zb2smt.bol;

import zb2smt.IPOPrint;

public class Card extends SetFunction {
	Expression expression;

	public Card() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("card (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}

	public boolean findDependency(BIdentifier bIdentifier) {
		return expression.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		Card cardClone = new Card();
		cardClone.setExpression(this.expression.cloneObject());
		return cardClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Card cardClone;
		Expression exp = (Expression) this.expression.substitute(dest, src);
		if (exp != expression) {
			cardClone = new Card();
			cardClone.expression = exp;
			return cardClone;
		} else {
			return this;
		}
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG,
			BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb,
			String indent) {
		print.printFormat(this, sb, indent);
	}

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}