package zb2smt.bol;

import zb2smt.IPOPrint;

public class Closure1 extends SetFunction {
	Expression set;

	public Closure1() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		set = (Expression) values[0];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("closure1 (");
		set.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return set.isFree(idents);
	}

	public boolean findDependency(BIdentifier arg0) {
		return set.findDependency(arg0);
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	public Expression cloneObject() {
		Closure1 closure1Clone = new Closure1();
		closure1Clone.set = this.set.cloneObject();
		return closure1Clone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Expression nset = (Expression) this.set.substitute(dest, src);
		if (nset == this.set)
			return this;
		Closure1 closureClone = new Closure1();
		closureClone.set = nset;
		return closureClone;
	}*/

	public Expression getSet() {
		return set;
	}

	public void setSet(Expression set) {
		this.set = set;
	}
}