package zb2smt.bol;

public abstract class CompareEnumeratedExpression extends CompareExpression {
	Expression left;

	Expression right;

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exp) {
		Expression nl, nr;
		nl = (Expression) this.left.substitute(identifiers, exp);
		nr = (Expression) this.right.substitute(identifiers, exp);
		if (nl != this.left || nr != this.right) {
			CompareEnumeratedExpression compare = null;
			if (this instanceof NotEqualEnumerated) {
				compare = new NotEqualEnumerated();
			} else if (this instanceof EqualEnumerated) {
				compare = new EqualEnumerated();
			}
			compare.left = nl;
			compare.right = nr;
			return compare;
		} else
			return this;
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	public Predicate cloneObject() {
		CompareEnumeratedExpression compare = null;
		if (this instanceof NotEqualEnumerated) {
			compare = new NotEqualEnumerated();
		} else if (this instanceof EqualEnumerated) {
			compare = new EqualEnumerated();
		}
		compare.left = left.cloneObject();
		compare.right = right.cloneObject();
		return compare;
	}

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}