package zb2smt.bol;

public abstract class CompareOrderedPairExpression extends CompareExpression {
	OrderedPair left;

	OrderedPair right;

	public void setFields(BObject[] values) {
		left = (OrderedPair) values[0];
		right = (OrderedPair) values[1];
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	public Predicate cloneObject() {
		CompareOrderedPairExpression orderedPairClone = null;
		if (this instanceof EqualOrderedPair)
			orderedPairClone = new EqualOrderedPair();
		else if (this instanceof NotEqualOrderedPair)
			orderedPairClone = new NotEqualOrderedPair();
		orderedPairClone.left = (OrderedPair) left.cloneObject();
		orderedPairClone.right = (OrderedPair) right.cloneObject();
		return orderedPairClone;
	}
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	public OrderedPair getLeft() {
		return left;
	}

	public void setLeft(OrderedPair left) {
		this.left = left;
	}

	public OrderedPair getRight() {
		return right;
	}

	public void setRight(OrderedPair right) {
		this.right = right;
	}
}