package zb2smt.bol;

public abstract class CompareSetExpression extends CompareExpression {
	Expression left;

	Expression right;

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exp) {
		Expression nl, nr;
		nl = (Expression) this.left.substitute(identifiers, exp);
		nr = (Expression) this.right.substitute(identifiers, exp);
		if (nl != this.left || nr != this.right) {
			CompareSetExpression compare;
			if (this instanceof NotEqualSet) {
				compare = new NotEqualSet();
			} else if (this instanceof EqualSet) {
				compare = new EqualSet();
			} else {
				System.out
						.println("ERRO: no m???odo Substitute do CompareSetExpression");
				System.out.println("	: Um tipo ainda n??? tratado");
				compare = new EqualSet();
			}
			compare.left = nl;
			compare.right = nr;
			return compare;
		} else
			return this;
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	public Predicate cloneObject() {
		CompareSetExpression compExClone = null;
		if (this instanceof NotEqualSet) {
			compExClone = new NotEqualSet();
		} else if (this instanceof EqualSet) {
			compExClone = new EqualSet();
		} else {
		}
		compExClone.left = left.cloneObject();
		compExClone.right = right.cloneObject();
		return compExClone;
	}

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}