package zb2smt.bol;

public class EffectiveParameters extends AuxiliaryClass {
	Expression[] expressions;

	public EffectiveParameters() {
	}

	public void setFields(BObject[] values) {
		expressions = new Expression[values.length];
		for (int i = 0; i < values.length; i += 1) {
			expressions[i] = ((Expression) values[i]);
		}
	}

	/*public void toBString(StringBuffer sb, String indent) {
		for (int i = 0; i < expressions.length; i++) {
			expressions[i].toBString(sb, indent);
			if (i != expressions.length - 1)
				sb = sb.append(",");
		}
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<idents.length;i++){
			if(!expressions[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	public Expression[] getExpressions() {
		return expressions;
	}

	public void setExpressions(Expression[] expressions) {
		this.expressions = expressions;
	}
}