package zb2smt.bol;

import zb2smt.IPOPrint;

public class Fnc extends SetFunction {
	Expression relation;

	public Fnc() {
	}

	public void setFields(BObject[] values) {
		relation = (Expression) values[0];
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return relation.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("fnc (");
		relation.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return relation.findDependency(arg0);
	}

	public Expression cloneObject() {
		Fnc fncClone = new Fnc();
		fncClone.relation = this.relation.cloneObject();
		return fncClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Expression r = (Expression) this.relation.substitute(dest, src);
		if (r == this.relation)
			return this;
		Fnc fncClone = new Fnc();
		fncClone.relation = r;
		return fncClone;
	}*/
	
	public Expression getRelation() {
		return relation;
	}

	public void setRelation(Expression relation) {
		this.relation = relation;
	}
}