package zb2smt.bol;

import zb2smt.IPOPrint;

public class Inverse extends SetFunction {
	Expression set;

	public Inverse() {
	}

	public void setFields(BObject[] values) {
		set = (Expression) values[0];
	}

	public boolean isFree(BIdentifier[] idents){
		return set.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		set.toBString(sb, indent);
		sb = sb.append("~");
	}*/

	public Expression cloneObject() {
		Inverse inverseClone = new Inverse();
		inverseClone.set = this.set.cloneObject();
		return inverseClone;
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean findDependency(BIdentifier arg0) {
		return set.findDependency(arg0);
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject[] array = new BObject[1];
		array[0] = set.substitute(dest, src);
		if (array[0] == this.set)
			return this;
		Inverse inverse = new Inverse();
		inverse.setFields(array);
		return inverse;
	}*/ 
	
	public Expression getSet() {
		return set;
	}

	public void setSet(Expression set) {
		this.set = set;
	}
}