package zb2smt.bol;

public class LocalOperation extends AuxiliaryClass {
	EntityName name;

	TypeResults results;

	TypeParameters parameters;

	LocalVariables variables;

	public LocalOperation() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		name = (EntityName) values[i];
		i += 1;
		if (i < values.length && values[i] instanceof TypeResults) {
			results = (TypeResults) values[i];
			i += 1;
		}
		if (i < values.length && values[i] instanceof TypeParameters) {
			parameters = (TypeParameters) values[i];
			i += 1;
		}
		if (i < values.length && values[i] instanceof LocalVariables) {
			variables = (LocalVariables) values[i];
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		return name.isFree(idents) && results.isFree(idents) && 
		parameters.isFree(idents) && variables.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		if (results != null) {
			results.toBString(sb, indent);
			sb = sb.append("<--");
		}
		name.toBString(sb, indent);
		if (parameters != null) {
			sb = sb.append("(");
			parameters.toBString(sb, indent);
			sb = sb.append(")");
		}
		if (variables != null) {
			sb = sb.append("\n" + indent + "{" + "\n");
			variables.toBString(sb, indent);
			sb = sb.append(indent + "}");
		}
	}*/

	public EntityName getName() {
		return name;
	}

	public void setName(EntityName name) {
		this.name = name;
	}

	public TypeParameters getParameters() {
		return parameters;
	}

	public void setParameters(TypeParameters parameters) {
		this.parameters = parameters;
	}

	public TypeResults getResults() {
		return results;
	}

	public void setResults(TypeResults results) {
		this.results = results;
	}

	public LocalVariables getVariables() {
		return variables;
	}

	public void setVariables(LocalVariables variables) {
		this.variables = variables;
	}
}