package zb2smt.bol;

public class LocalParameters extends AuxiliaryClass {
	LocalParameter[] parameters;

	public LocalParameters() {
	}

	public void setFields(BObject[] values) {
		parameters = new LocalParameter[values.length];
		for (int i = 0; i < values.length; i += 1) {
			parameters[i] = ((LocalParameter) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<parameters.length;i++){
			if(!parameters[i].isFree(idents)){
				return false;
			}
		}		
		
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("\nLocalParameters :\n");
		for (int i = 0; i < parameters.length; i++)
			parameters[i].toBString(sb, indent.concat("  "));
		sb = sb.append("\n");
	}*/

	public LocalParameter[] getParameters() {
		return parameters;
	}

	public void setParameters(LocalParameter[] parameters) {
		this.parameters = parameters;
	}

	public LocalParameter getParameter(int i) {
		return parameters[i];
	}

	public void setParameter(LocalParameter parameter, int i) {
		this.parameters[i] = parameter;
	}
}