package zb2smt.bol;

import zb2smt.IPOPrint;

public class Max extends SetFunction {
	Expression integerSet;

	public Max() {
	}

	public void setFields(BObject[] values) {
		integerSet = (Expression) values[0];
	}

	public boolean isFree(BIdentifier[] idents){
		return integerSet.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("max (");
		integerSet.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean findDependency(BIdentifier bIdentifier) {
		return integerSet.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		Max maxClone = new Max();
		maxClone.integerSet = this.integerSet.cloneObject();
		return maxClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Max maxClone;
		Expression exp = (Expression) this.integerSet.substitute(dest, src);
		if (exp != integerSet) {
			maxClone = new Max();
			maxClone.integerSet = exp;
			return maxClone;
		} else {
			return this;
		}
	}*/ 
	
	public Expression getIntegerSet() {
		return integerSet;
	}

	public void setIntegerSet(Expression integerSet) {
		this.integerSet = integerSet;
	}
}