package zb2smt.bol;

import zb2smt.IPOPrint;

public class Permutation extends SequenceFunction {
	Expression expression;

	public Permutation() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}

/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("perm (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public Expression cloneObject() {
		Permutation permutationClone;
		permutationClone = new Permutation();
		permutationClone.expression = expression.cloneObject();
		return permutationClone;
	}
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Permutation permutationClone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			permutationClone = new Permutation();
			permutationClone.expression = exp;
			return permutationClone;
		} else {
			return this;
		}
	} */
	
	
	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}