package zb2smt.bol;

import zb2smt.IPOPrint;

public class Reverse extends SequenceFunction {
	Expression expression;

	public Reverse() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("rev (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}

	public Expression cloneObject() {
		Reverse reverseClone;
		reverseClone = new Reverse();
		reverseClone.expression = expression.cloneObject();
		return reverseClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Reverse reverseClone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			reverseClone = new Reverse();
			reverseClone.expression = exp;
			return reverseClone;
		} else {
			return this;
		}
	}*/
	
	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}