package zb2smt.bol;

import zb2smt.IPOPrint;

public class Seq1 extends SequenceFunction {
	Expression expression;

	public Seq1() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("seq1(");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}
	
	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}

	public Expression cloneObject() {
		Seq1 seq1Clone;
		seq1Clone = new Seq1();
		seq1Clone.expression = expression.cloneObject();
		return seq1Clone;
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Seq1 seq1Clone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			seq1Clone = new Seq1();
			seq1Clone.expression = exp;
			return seq1Clone;
		} else {
			return this;
		}
	}*/

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}