package zb2smt.bol;

public class Var extends Substitution {
	BIdentifier[] bidentifiers;

	Substitution substitution;

	public Var() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		bidentifiers = new BIdentifier[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			bidentifiers[i] = (BIdentifier) values[i];
		}
		substitution = (Substitution) values[values.length - 1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<bidentifiers.length;i++){
			if(!bidentifiers[i].isFree(idents)){
				return false;
			}
		}
		return substitution.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "VAR ");
		for (int i = 0; i < bidentifiers.length; i++)
			bidentifiers[i].toBString(sb, indent);
		sb = sb.append(" IN\n");
		substitution.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "END");
	}*/

	public Predicate toSubstitute(Predicate inv) {
		System.out.println("Substitui�o ainda indefinida: Var");
		return inv;
	}

	public BIdentifier[] getBidentifiers() {
		return bidentifiers;
	}

	public void setBidentifiers(BIdentifier[] bidentifiers) {
		this.bidentifiers = bidentifiers;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}
}