/*
 * Created on 25/05/2006
 *
 * 
 * Window - Preferences - Java - Code Style - Code Templates
 */

package zb2smt;

import java.util.LinkedList;

import zb2smt.bol.*;
/**
 * @author eberton
 * 
 * 
 * Preferences - Java - Code Style - Code Templates
 */
public interface IPOPrint {

	public String getExtension();

	/** TODO - Retirar dest desta funcao*/
	public void toPOPrintFormat(LinkedList pOList, StringBuffer sb,
			String indent, String dest, String archiveName);

	/*Adicionais ainda sem ordem */
	abstract public void printFormat(IntegerValue integervalue, StringBuffer sb, String indent);
	
	abstract public void printFormat(Modulo modulo, StringBuffer sb, String indent);
	
	abstract public void printFormat(LessThanOrEqual lessThanOrEqual, StringBuffer sb,
			String indent);
	abstract public void printFormat(LessThan lessThan, StringBuffer sb,
			String indent);	
	
	abstract public void printFormat(Interval interval, StringBuffer sb,
			String indent);	
	
	abstract public void printFormat(Minus minus, StringBuffer sb,
			String indent);
		
	abstract public void printFormat(ExtensionSet extensionset, StringBuffer sb,
			String indent);
	abstract public void printFormat(GreatherThan greatherThan, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(GreatherThanOrEqual greatherThanOrEqual, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(BBoolean bboolean, StringBuffer sb,
			String indent);
	
	
	abstract public void printFormat(BooleanSet booleanset, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(BooleanExpression booleanexpression, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Card card, StringBuffer sb, String indent);

	abstract public void printFormat(Division division, StringBuffer sb, String indent);
	
	abstract public void printFormat(EqualEnumerated equalEnumerated, StringBuffer sb,String indent);
	
	abstract public void printFormat(FinitePowerSet finitePowerSet, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EqualBoolean notEqualBoolean, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(NotEqualBoolean notEqualBoolean, StringBuffer sb,
			String indent);
	abstract public void printFormat(NotEqualEnumerated notEqualEnumerated,
			StringBuffer sb, String indent);
	
	abstract public void printFormat(PowerSet powerset, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Product product, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(NonEmptySubsets nonemptysubsets, StringBuffer sb,
			String indent);
	
	
	abstract public void printFormat(Results results, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(StringSet stringSet, StringBuffer sb, String indent);
	
	/*>Adicionais ainda sem ordem */
	
	abstract public void printFormat(Implication implication, StringBuffer sb,
			String indent);

	abstract public void printFormat(Or or, StringBuffer sb, String indent);

	abstract public void printFormat(And and, StringBuffer sb, String indent);

	abstract public void printFormat(Equivalence equivalence, StringBuffer sb,
			String indent);

	abstract public void printFormat(ForAll forAll, StringBuffer sb, String indent);

	abstract public void printFormat(Exists exists, StringBuffer sb, String indent);

	abstract public void printFormat(Not not, StringBuffer sb, String indent);

	abstract public void printFormat(NotEqual notEqual, StringBuffer sb, String indent);

	abstract public void printFormat(Equal equal, StringBuffer sb, String indent);

	abstract public void printFormat(NotEqualSet notEqualSet, StringBuffer sb,
			String indent);

	abstract public void printFormat(EqualSet equalSet, StringBuffer sb, String indent);

	abstract public void printFormat(In in, StringBuffer sb, String indent);

	abstract public void printFormat(NotSetMemberShip notSetMemberShip, StringBuffer sb,
			String indent);

	abstract public void printFormat(Subset subset, StringBuffer sb, String indent);

	abstract public void printFormat(StrictSubset strictSubset, StringBuffer sb,
			String indent);

	abstract public void printFormat(NotSubset notSubset, StringBuffer sb, String indent);

	abstract public void printFormat(NotStrictSubset notStrictSubSet, StringBuffer sb,
			String indent);

	abstract public void printFormat(Union union, StringBuffer sb, String indent);

	abstract public void printFormat(Intersection intersection, StringBuffer sb,
			String indent);

	abstract public void printFormat(SetMinus setMinus, StringBuffer sb, String indent);

	abstract public void printFormat(EmptySet emptySet, StringBuffer sb, String indent);

	abstract public void printFormat(BIdentifier bIdentifier, StringBuffer sb,
			String indent);

	abstract public void printFormat(BInteger bInteger, StringBuffer sb, String indent);

	abstract public void printFormat(IntegerSet integerSet, StringBuffer sb,
			String indent);

	abstract public void printFormat(Plus plus, StringBuffer sb,
			String indent);
	
	
	abstract public void printFormat(UnaryMinus unaryMinus, StringBuffer sb,
			String indent);
	

	
	abstract public void printFormat(BString bstring, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EqualOrderedPair equalOrderedPair, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EqualSequence equalSequence, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(NotEqualOrderedPair notEqualOrderedPair, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(NotEqualSequence notEqualSequence, StringBuffer sb,
			String indent);

	
	
	
	abstract public void printFormat(Append append, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(ArrayElement arrayElement, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(BEnumeratedValue bEnumeratedValue, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(BPreviousValue bPreviousValue, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(CallFunction callFunction, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(CartesianProduct cartesianProduct, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Closure closure, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Closure1 closure1, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Composition composition, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(ComprehensionSet comprehensionSet, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Concatenate concatenate, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(DirectProduct directProduct, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Domain domain, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(DomainRestriction domainRestriction, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(DomainSubstraction domainSubstraction, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EmptySequence emptySequence, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(ExtensionSequence extensionSequence, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(First first, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Fnc fnc, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Front front, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(GeneralizedConcatenation generalizedConcatenation, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(GeneralizedIntersection generalizedIntersection, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(GeneralizedUnion generalizedUnion, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Identity identity, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Image image, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Inverse inverse, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(ISeq iSeq, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(ISeq1 iSeq1, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Iterate iterate, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Lambda lambda, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Last last, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Max max, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Min min, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(NonEmptyFiniteSubsets nonEmptyFiniteSubsets, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(OrderedPair orderedPair, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Overriding overriding, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(ParallelProduct parallelProduct, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(PartialBijection partialBijection, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(PartialFunction partialFunction, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(PartialInjection partialInjection, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(PartialSurjection partialSurjection, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Permutation permutation, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Pi pi, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Power power, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Pred pred, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Prefix prefix, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Prepend prepend, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Projection1 projection1, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Projection2 projection2, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(QuantifiedIntersection quantifiedIntersection, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(QuantifiedUnion quantifiedUnion, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Range range, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(RangeRestriction rangeRestriction, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(RangeSubstraction rangeSubstraction, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Rel rel, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Relation relation, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Reverse reverse, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Seq seq, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Seq1 seq1, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Sigma sigma, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Size size, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Succ succ, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Suffix suffix, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(Tail tail, StringBuffer sb,
			String indent);
	
	
	abstract public void printFormat(TotalBijection totalBijection, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TotalFunction totalFunction, StringBuffer sb,
			String indent);
	abstract public void printFormat(TotalInjection totalInjection, StringBuffer sb,
			String indent);
	abstract public void printFormat(TotalSurjection totalSurjection, StringBuffer sb,
			String indent);
	
	
	
	abstract public void printFormat(EntityInstance entityInstance, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EntityLocalization entityLocation, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EntityName entityName, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeBool typeBool, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeIdentifier typeIdentifier, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeParameter typeParameter, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeResult typeResult, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeCartesianProduct typeCartesianProduct, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeReference typeReference, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypePowerSet typePowerSet, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeParameters typeParameters, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeResults typeResults, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeString typeString, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(TypeInteger entityType, StringBuffer sb,
			String indent);
	
	abstract public void printFormat(EntityType entityType, StringBuffer sb,
			String indent);
	
	/*
	 * Criado
	 */
	
	public void printFormat(PredicateExpression expression, StringBuffer sb, String indent);
	

	/*
	 * abstract public void printFormatAnd(And obj, StringBuffer sb, String indent){
	 * System.out.println("Object "+obj.getClass().getName()); }
	 */

}
