package zb2smt.bol;


public class Any extends Substitution {
	BIdentifier[] identifiers;

	Predicate predicate;

	Substitution substitution;

	public Any() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 2];
		for (i = values.length - 3; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		predicate = (Predicate) values[values.length - 2];
		substitution = (Substitution) values[values.length - 1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "ANY ");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append("\n" + indent + "WHERE\n");
		predicate.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "THEN\n");
		substitution.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "END\n");
	}*/

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents) && substitution.isFree(idents);
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}
}