package zb2smt.bol;

import zb2smt.IPOPrint;

public class BInteger extends AtomicElement {
	public BInteger() {
	}

	public void setFields(String value) {
		this.value = value;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(value);
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return value.equals(bIdentifier.value);
	}

	public Expression cloneObject() {
		BInteger bIntegerClone;
		bIntegerClone = new BInteger();
		bIntegerClone.value = new String(value);
		return bIntegerClone;
	}

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exps) {
		return this;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
}