package zb2smt.bol;


public abstract class BinaryArithmeticExpression extends ArithmeticExpression {
	Expression left;

	Expression right;

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	public boolean findDependency(BIdentifier arg0) {
		return left.findDependency(arg0) || right.findDependency(arg0);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BinaryArithmeticExpression binaryArithmeticExpression = null;
		Expression left = (Expression) this.left.substitute(dest, src);
		Expression right = (Expression) this.right.substitute(dest, src);
		if (left != this.left || right != this.right) {
			if (this instanceof Plus) {
				binaryArithmeticExpression = new Plus();
			} else if (this instanceof Minus) {
				binaryArithmeticExpression = new Minus();
			} else if (this instanceof Division) {
				binaryArithmeticExpression = new Division();
			} else if (this instanceof Product) {
				binaryArithmeticExpression = new Product();
			} else if (this instanceof Modulo) {
				binaryArithmeticExpression = new Modulo();
			} else if (this instanceof Power) {
				binaryArithmeticExpression = new Power();
			}
			binaryArithmeticExpression.left = left;
			binaryArithmeticExpression.right = right;
			return binaryArithmeticExpression;
		} else {
			return this;
		}
	}*/

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}