package zb2smt.bol;


public abstract class BinarySetExpression extends SetExpression {
	Expression left;

	Expression right;

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	public boolean findDependency(BIdentifier bIdentifier) {
		return left.findDependency(bIdentifier)
				|| right.findDependency(bIdentifier);
	}

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exp) {
		Expression nl, nr;
		nl = (Expression) left.substitute(identifiers, exp);
		nr = (Expression) right.substitute(identifiers, exp);
		if (nl == this.left && nr == this.right)
			return this;
		BinarySetExpression binarySetExpression = null;
		if (this instanceof CartesianProduct) {
			binarySetExpression = new CartesianProduct();
		} else if (this instanceof ParallelProduct) {
			binarySetExpression = new ParallelProduct();
		} else if (this instanceof Relation) {
			binarySetExpression = new Relation();
		} else if (this instanceof TotalFunction) {
			binarySetExpression = new TotalFunction();
		} else if (this instanceof PartialFunction) {
			binarySetExpression = new PartialFunction();
		} else if (this instanceof TotalSurjection) {
			binarySetExpression = new TotalSurjection();
		} else if (this instanceof PartialSurjection) {
			binarySetExpression = new PartialSurjection();
		} else if (this instanceof TotalInjection) {
			binarySetExpression = new TotalInjection();
		} else if (this instanceof PartialInjection) {
			binarySetExpression = new PartialInjection();
		} else if (this instanceof TotalBijection) {
			binarySetExpression = new TotalBijection();
		} else if (this instanceof PartialBijection) {
			binarySetExpression = new PartialBijection();
		} else if (this instanceof Union) {
			binarySetExpression = new Union();
		} else if (this instanceof Intersection) {
			binarySetExpression = new Intersection();
		} else if (this instanceof SetMinus) {
			binarySetExpression = new SetMinus();
		} else if (this instanceof Composition) {
			binarySetExpression = new Composition();
		} else if (this instanceof DirectProduct) {
			binarySetExpression = new DirectProduct();
		} else if (this instanceof DomainRestriction) {
			binarySetExpression = new DomainRestriction();
		} else if (this instanceof DomainSubstraction) {
			binarySetExpression = new DomainSubstraction();
		} else if (this instanceof RangeRestriction) {
			binarySetExpression = new RangeRestriction();
		} else if (this instanceof RangeSubstraction) {
			binarySetExpression = new RangeSubstraction();
		} else if (this instanceof Overriding) {
			binarySetExpression = new Overriding();
		} else if (this instanceof Image) {
			binarySetExpression = new Image();
		}
		binarySetExpression.left = nl;
		binarySetExpression.right = nr;
		return binarySetExpression;
	}*/

	public Expression cloneObject() {
		BinarySetExpression binarySetExpression = null;
		if (this instanceof CartesianProduct) {
			binarySetExpression = new CartesianProduct();
		} else if (this instanceof ParallelProduct) {
			binarySetExpression = new ParallelProduct();
		} else if (this instanceof Relation) {
			binarySetExpression = new Relation();
		} else if (this instanceof TotalFunction) {
			binarySetExpression = new TotalFunction();
		} else if (this instanceof PartialFunction) {
			binarySetExpression = new PartialFunction();
		} else if (this instanceof TotalSurjection) {
			binarySetExpression = new TotalSurjection();
		} else if (this instanceof PartialSurjection) {
			binarySetExpression = new PartialSurjection();
		} else if (this instanceof TotalInjection) {
			binarySetExpression = new TotalInjection();
		} else if (this instanceof PartialInjection) {
			binarySetExpression = new PartialInjection();
		} else if (this instanceof TotalBijection) {
			binarySetExpression = new TotalBijection();
		} else if (this instanceof PartialBijection) {
			binarySetExpression = new PartialBijection();
		} else if (this instanceof Union) {
			binarySetExpression = new Union();
		} else if (this instanceof Intersection) {
			binarySetExpression = new Intersection();
		} else if (this instanceof SetMinus) {
			binarySetExpression = new SetMinus();
		} else if (this instanceof Composition) {
			binarySetExpression = new Composition();
		} else if (this instanceof DirectProduct) {
			binarySetExpression = new DirectProduct();
		} else if (this instanceof DomainRestriction) {
			binarySetExpression = new DomainRestriction();
		} else if (this instanceof DomainSubstraction) {
			binarySetExpression = new DomainSubstraction();
		} else if (this instanceof RangeRestriction) {
			binarySetExpression = new RangeRestriction();
		} else if (this instanceof RangeSubstraction) {
			binarySetExpression = new RangeSubstraction();
		} else if (this instanceof Overriding) {
			binarySetExpression = new Overriding();
		} else if (this instanceof Image) {
			binarySetExpression = new Image();
		}
		binarySetExpression.left = left.cloneObject();
		binarySetExpression.right = right.cloneObject();
		return binarySetExpression;
	}
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}