package zb2smt.bol;

public class Case extends Substitution {
	Expression expression;

	OneCase[] cases;

	Substitution elseSubstitution;

	public Case() {
	}

	public void setFields(BObject[] values) {
		int bsup;
		expression = (Expression) values[0];
		if (values[values.length - 1] instanceof Substitution) {
			elseSubstitution = (Substitution) values[values.length - 1];
			bsup = values.length - 1;
		} else {
			bsup = values.length;
		}
		cases = new OneCase[bsup - 1];
		for (int i = 1; i < bsup; i += 1) {
			cases[i - 1] = ((OneCase) values[i]);
		}
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "CASE ");
		expression.toBString(sb, indent);
		sb = sb.append(" OF\n" + indent.concat("  ") + "EITHER ");
		for (int i = 0; i < cases.length; i++) {
			cases[i].toBString(sb, indent.concat("  "));
			if (i != cases.length - 1)
				sb = sb.append("\n" + indent.concat("  ") + "OR ");
		}
		if (elseSubstitution != null) {
			sb = sb.append("\n" + indent.concat("  ") + "ELSE\n");
			elseSubstitution.toBString(sb, indent.concat("    "));
		}
		sb = sb.append("\n" + indent.concat("  ") + "END ");
		sb = sb.append("\n" + indent + "END ");
	}*/

	public boolean isFree(BIdentifier[] idents){
		if(!expression.isFree(idents)){
			return false;
		}
		for(int i=0;i<cases.length;i++){
			for(int j=0;j<idents.length;j++){
				if(!cases[i].isFree(idents)){
					return false;
				}
			}
		}
		return elseSubstitution.isFree(idents);
	}
	
	public OneCase[] getCases() {
		return cases;
	}

	public void setCases(OneCase[] cases) {
		this.cases = cases;
	}

	public Substitution getElseSubstitution() {
		return elseSubstitution;
	}

	public void setElseSubstitution(Substitution elseSubstitution) {
		this.elseSubstitution = elseSubstitution;
	}

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}