package zb2smt.bol;

public abstract class CompareArithmeticExpression extends CompareExpression {
	Expression left;

	Expression right;

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	//abstract public void toBString(StringBuffer sb, String indent);

	/*public BObject substitute(BIdentifier[] identifiers, Expression[] exps) {
		Expression nl, nr;
		nl = (Expression) this.left.substitute(identifiers, exps);
		nr = (Expression) this.right.substitute(identifiers, exps);
		if (nl != left || nr != right) {
			CompareArithmeticExpression compres = null;
			if (this instanceof LessThan) {
				compres = new LessThan();
			} else if (this instanceof LessThanOrEqual) {
				compres = new LessThanOrEqual();
			} else if (this instanceof GreatherThan) {
				compres = new GreatherThan();
			} else if (this instanceof GreatherThanOrEqual) {
				compres = new GreatherThanOrEqual();
			} else if (this instanceof NotEqual) {
				compres = new NotEqual();
			} else if (this instanceof Equal) {
				compres = new Equal();
			}
			compres.left = nl;
			compres.right = nr;
			return compres;
		} else {
			return this;
		}
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	public Predicate cloneObject() {
		CompareArithmeticExpression compres = null;
		if (this instanceof LessThan) {
			compres = new LessThan();
		} else if (this instanceof LessThanOrEqual) {
			compres = new LessThanOrEqual();
		} else if (this instanceof GreatherThan) {
			compres = new GreatherThan();
		} else if (this instanceof GreatherThanOrEqual) {
			compres = new GreatherThanOrEqual();
		} else if (this instanceof NotEqual) {
			compres = new NotEqual();
		} else if (this instanceof Equal) {
			compres = new Equal();
		}
		compres.left = left.cloneObject();
		compres.right = right.cloneObject();
		return compres;
	}

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}