package zb2smt.bol;


public class ElseIf extends AuxiliaryClass {
	Predicate predicate;

	Substitution substitution;

	public ElseIf() {
	}

	public void setFields(BObject[] values) {
		predicate = (Predicate) values[0];
		substitution = (Substitution) values[1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return predicate.isFree(idents) && substitution.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb.append(indent + "ESLEIF\n");
		predicate.toBString(sb, indent.concat("  "));
		sb.append("\n" + indent + "THEN\n");
		substitution.toBString(sb, indent.concat("  "));
	}*/
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}
}