package zb2smt.bol;

import zb2smt.IPOPrint;

public class Equivalence extends BinaryPredicate {
	public Equivalence() {
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("(");
		left.toBString(sb, indent);
		sb = sb.append(" <=> ");
		right.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public Predicate cloneObject() {
		Equivalence equivalenceClone;
		equivalenceClone = new Equivalence();
		equivalenceClone.left = left.cloneObject();
		equivalenceClone.right = right.cloneObject();
		return equivalenceClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject[] b = new BObject[2];
		b[0] = left.substitute(dest, src);
		b[1] = right.substitute(dest, src);
		if (b[0] != this.left || b[1] != this.right) {
			Equivalence equivalence = new Equivalence();
			equivalence.setFields(b);
			return equivalence;
		} else
			return this;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
}