package zb2smt.bol;

import zb2smt.IPOPrint;
public class ExternOperations extends AuxiliaryClass {
	ExternOperation[] operations;

	public ExternOperations() {
	}

	public void setFields(BObject[] values) {
		operations = new ExternOperation[values.length];
		for (int i = 0; i < values.length; i += 1) {
			operations[i] = ((ExternOperation) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<operations.length;i++){
			if(!operations[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("ExternOperations :\n");
		for (int i = 0; i < operations.length; i++) {
			operations[i].toBString(sb, indent.concat("  "));
			sb = sb.append("\n");
		}
		sb = sb.append("\n");
	}*/

	public ExternOperation[] getOperations() {
		return operations;
	}

	public void setOperations(ExternOperation[] operations) {
		this.operations = operations;
	}
	
	/*public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}*/
}