package zb2smt.bol;

import zb2smt.IPOPrint;

public class First extends SequenceFunction {
	Expression expression;

	public First() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("first (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}

	public Expression cloneObject() {
		First firstClone;
		firstClone = new First();
		firstClone.expression = expression.cloneObject();
		return firstClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		First firstClone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			firstClone = new First();
			firstClone.expression = exp;
			return firstClone;
		} else {
			return this;
		}
	}*/
	
	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}