package zb2smt.bol;

public class FormalParameters extends AuxiliaryClass {
	BIdentifier[] identifiers;

	public FormalParameters() {
	}

	public void setFields(BObject[] values) {
		identifiers = new BIdentifier[values.length];
		for (int i = 0; i < values.length; i += 1) {
			identifiers[i] = ((BIdentifier) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
	}*/

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifier(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}
}