package zb2smt.bol;

import zb2smt.IPOPrint;

public class Front extends SequenceFunction {
	Expression expression;

	public Front() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("front (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}

	public Expression cloneObject() {
		Front frontClone;
		frontClone = new Front();
		frontClone.expression = expression.cloneObject();
		return frontClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Front frontClone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			frontClone = new Front();
			frontClone.expression = exp;
			return frontClone;
		} else {
			return this;
		}
	} */
	
	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}