package zb2smt.bol;

import zb2smt.IPOPrint;

public class ISeq1 extends SequenceFunction {
	Expression expression;

	public ISeq1() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("iseq1 (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}

	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public Expression cloneObject() {
		ISeq1 iSeq1Clone;
		iSeq1Clone = new ISeq1();
		iSeq1Clone.expression = expression.cloneObject();
		return iSeq1Clone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		ISeq1 iseq1Clone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			iseq1Clone = new ISeq1();
			iseq1Clone.expression = exp;
			return iseq1Clone;
		} else {
			return this;
		}
	}*/ 
	
	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}