package zb2smt.bol;

import zb2smt.IPOPrint;

public class Identity extends SetFunction {
	Expression set;

	public Identity() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		set = (Expression) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return set.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("id (");
		set.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return set.findDependency(arg0);
	}

	public Expression cloneObject() { /* Verificar se OK ? */
		Identity identityClone = new Identity();
		identityClone.set = this.set.cloneObject();
		return identityClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject[] array = new BObject[1];
		array[0] = set.substitute(dest, src);
		if (array[0] == this.set)
			return this;
		Identity identity = new Identity();
		identity.setFields(array);
		return identity;
	}*/
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	public Expression getSet() {
		return set;
	}

	public void setSet(Expression set) {
		this.set = set;
	}
}