package zb2smt.bol;

import zb2smt.IPOPrint;

public class Implication extends BinaryPredicate {
	public Implication() {
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("(");
		left.toBString(sb, indent);
		sb = sb.append(" => ");
		right.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public Predicate cloneObject() {
		Implication implicationClone;
		implicationClone = new Implication();
		implicationClone.left = left.cloneObject();
		implicationClone.right = right.cloneObject();
		return implicationClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject[] b = new BObject[2];
		b[0] = left.substitute(dest, src);
		b[1] = right.substitute(dest, src);
		if (b[0] != this.left || b[1] != this.right) {
			Implication subst = new Implication();
			subst.setFields(b);
			return subst;
		} else
			return this;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
}