package zb2smt.bol;

import zb2smt.IPOPrint;

public class IntegerSet extends SetExpression {
	String value;

	public IntegerSet() {
	}

	public void setFields(String value) {
		this.value = value;
	}

	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<idents.length;i++){
			if(idents[i].getValue().equals(value)){
				return false;
			}
		}
		return true;
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(value);
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return value.equals(bIdentifier.value);
	}

	public Expression cloneObject() { 
		IntegerSet IntegerSetClone = new IntegerSet();
		IntegerSetClone.value = new String(this.value);
		return IntegerSetClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		return this;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}
}