package zb2smt.bol;

import zb2smt.IPOPrint;

public class IntegerValue extends ArithmeticExpression {
	BInteger value;

	public IntegerValue() {
	}

	public void setFields(BObject[] values) {
		value = (BInteger) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<idents.length;i++){
			if(idents[i].getValue().equals(value)){
				return false;
			}
		}
		return true;
	}
	/*public void toBString(StringBuffer sb, String indent) {
		value.toBString(sb, indent);
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return value.value.equals(arg0.value);
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public Expression cloneObject() {
		IntegerValue integerValueClone;
		integerValueClone = new IntegerValue();
		integerValueClone.value = (BInteger) (value.cloneObject());
		return integerValueClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		return this;
	}*/

	public BInteger getValue() {
		return value;
	}

	public void setValue(BInteger value) {
		this.value = value;
	}
}