package zb2smt.bol;

import zb2smt.IPOPrint;

public class Iterate extends SetFunction {
	Expression set;

	Expression n;

	public Iterate() {
	}

	public void setFields(BObject[] values) {
		set = (Expression) values[0];
		n = (Expression) values[1];
	}

	public boolean isFree(BIdentifier[] idents){
		return set.isFree(idents) && n.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		set.toBString(sb, indent);
		sb = sb.append("iterate (");
		n.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean findDependency(BIdentifier arg0) {
		return set.findDependency(arg0);
	}

	public Expression cloneObject() {
		Iterate iterateClone = new Iterate();
		iterateClone.set = this.set.cloneObject();
		iterateClone.n = this.n.cloneObject();
		return iterateClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Expression s1 = (Expression) this.set.substitute(dest, src);
		Expression nn = (Expression) this.n.substitute(dest, src);
		if (s1 == this.set && nn == this.n)
			return this;
		Iterate iterateClone = new Iterate();
		iterateClone.set = s1;
		iterateClone.n = nn;
		return iterateClone;
	}*/ 
	
	public Expression getN() {
		return n;
	}

	public void setN(Expression n) {
		this.n = n;
	}

	public Expression getSet() {
		return set;
	}

	public void setSet(Expression set) {
		this.set = set;
	}
}