package zb2smt.bol;


public class LetDefinition extends AuxiliaryClass {
	BIdentifier identifier;

	Expression expression;

	public LetDefinition() {
	}

	public void setFields(BObject[] values) {
		identifier = (BIdentifier) values[0];
		expression = (Expression) values[1];
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return identifier.isFree(idents) && expression.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		identifier.toBString(sb, indent);
		sb = sb.append(" = ");
		expression.toBString(sb, indent);
	}*/

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}

	public BIdentifier getIdentifier() {
		return identifier;
	}

	public void setIdentifier(BIdentifier identifier) {
		this.identifier = identifier;
	}
}