package zb2smt.bol;

import zb2smt.IPOPrint;

public class Min extends SetFunction {
	Expression integerSet;

	public Min() {
	}

	public void setFields(BObject[] values) {
		integerSet = (Expression) values[0];
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return integerSet.isFree(idents);
	}
	
/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("min (");
		integerSet.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return integerSet.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		Min minClone = new Min();
		minClone.integerSet = this.integerSet.cloneObject();
		return minClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
/*	public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Min minClone;
		Expression exp = (Expression) this.integerSet.substitute(dest, src);
		if (exp != integerSet) {
			minClone = new Min();
			minClone.integerSet = exp;
			return minClone;
		} else {
			return this;
		}
	}*/
	
	public Expression getIntegerSet() {
		return integerSet;
	}

	public void setIntegerSet(Expression integerSet) {
		this.integerSet = integerSet;
	}
}