package zb2smt.bol;

import zb2smt.IPOPrint;

public class Not extends Predicate {
	Predicate predicate;

	public Not() {
	}

	public void setFields(BObject[] values) {
		predicate = (Predicate) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return predicate.isFree(idents);
	}

/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("(");
		sb = sb.append("not (");
		predicate.toBString(sb, indent);
		sb = sb.append(")");
		sb = sb.append(")");
	}*/

	public Predicate cloneObject() {
		Not notClone;
		BObject[] bObjectClone;
		notClone = new Not();
		bObjectClone = new BObject[1];
		bObjectClone[0] = predicate.cloneObject();
		notClone.setFields(bObjectClone);
		return notClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject[] b = new BObject[1];
		b[0] = predicate.substitute(dest, src);
		if (b[0] != this) {
			Not not = new Not();
			not.setFields(b);
			return not;
		} else
			return this;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}
}