package zb2smt.bol;

public class OneCase extends AuxiliaryClass {
	Expression[] termes;

	Substitution substitution;

	public OneCase() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		termes = new Expression[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			termes[i] = (Expression) values[i];
		}
		substitution = (Substitution) values[values.length - 1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		for (int i = 0; i < termes.length; i++) {
			termes[i].toBString(sb, indent);
			if (i != termes.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(" THEN\n");
		substitution.toBString(sb, indent.concat("  "));
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return substitution.isFree(idents);
	}
	
	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}

	public Expression[] getTermes() {
		return termes;
	}

	public void setTermes(Expression[] termes) {
		this.termes = termes;
	}
}