package zb2smt.bol;


public class Precondition extends Substitution {
	Predicate precondition;

	Substitution substitution;

	public Precondition() {
	}

	public void setFields(BObject[] values) {
		precondition = (Predicate) values[0];
		substitution = (Substitution) values[1];
	}

	public boolean isFree(BIdentifier[] idents){
		return precondition.isFree(idents) && substitution.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "PRE\n");
		precondition.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "THEN\n");
		substitution.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "END");
	}*/

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public Predicate getPrecondition() {
		return precondition;
	}

	public void setPrecondition(Predicate precondition) {
		this.precondition = precondition;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}
}