package zb2smt.bol;

public class ReferencedBComponents extends AuxiliaryClass {
	ReferencedBComponent[] references;

	public ReferencedBComponents() {
	}

	public void setFields(BObject[] values) {
		references = new ReferencedBComponent[values.length];
		for (int i = 0; i < values.length; i += 1) {
			references[i] = ((ReferencedBComponent) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<references.length;i++){
			if(!references[i].isFree(idents)){
				return false;
			}
		}		
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("ReferencedBComponents :\n");
		for (int i = 0; i < references.length; i++) {
			references[i].toBString(sb, indent.concat("  "));
			sb = sb.append("\n");
		}
		sb = sb.append("\n");
	}*/

	public ReferencedBComponent[] getReferences() {
		return references;
	}

	public void setReferences(ReferencedBComponent[] references) {
		this.references = references;
	}
}