package zb2smt.bol;

import zb2smt.IPOPrint;;

public class Size extends SequenceFunction {
	Expression expression;

	public Size() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}

/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("size (");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}

	public Expression cloneObject() {
		Size sizeClone;
		sizeClone = new Size();
		sizeClone.expression = expression.cloneObject();
		return sizeClone;
	}
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

/*	public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Size sizeClone;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			sizeClone = new Size();
			sizeClone.expression = exp;
			return sizeClone;
		} else {
			return this;
		}
	}*/

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}