package zb2smt.bol;

import zb2smt.IPOPrint;

public class TypeParameters extends AuxiliaryClass {
	TypeParameter[] parameters;

	public TypeParameters() {
	}

	public void setFields(BObject[] values) {
		parameters = new TypeParameter[values.length];
		for (int i = 0; i < values.length; i += 1) {
			parameters[i] = ((TypeParameter) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<parameters.length;i++){
			if(!parameters[i].isFree(idents)){
				return false;
			}
		}		
		
		return true;
	}

	public TypeParameter[] getParameters() {
		return parameters;
	}
	
	public TypeParameter getParameter(int i) {
		return parameters[i];
	}

	public void setParameters(TypeParameter[] parameters) {
		this.parameters = parameters;
	}
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
}