package zb2smt.bol;

import zb2smt.IPOPrint;

public class TypeResults extends AuxiliaryClass {
	TypeResult[] results;

	public TypeResults() {
	}

	public void setFields(BObject[] values) {
		results = new TypeResult[values.length];
		for (int i = 0; i < values.length; i += 1) {
			results[i] = ((TypeResult) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<results.length;i++){
			if(!results[i].isFree(idents)){
				return false;
			}
		}		
		return true;
	}

/*	public void toBString(StringBuffer sb, String indent) {
		for (int i = 0; i < results.length; i++) {
			results[i].toBString(sb, indent.concat("  "));
			if (i != results.length - 1)
				sb = sb.append(",");
		}
	}*/

	public TypeResult[] getResults() {
		return results;
	}
	
	public TypeResult getResult(int i) {
		return results[i];
	}


	public void setResults(TypeResult[] results) {
		this.results = results;
	}
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
}