package zb2smt.bol;

import zb2smt.IPOPrint;

public class UnaryMinus extends ArithmeticExpression {
	Expression expression;

	public UnaryMinus() {
	}

	public void setFields(BObject[] values) {
		expression = (Expression) values[0];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return expression.isFree(idents);
	}

/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("-");
		expression.toBString(sb, indent);
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return expression.findDependency(arg0);
	}

	public Expression cloneObject() {
		UnaryMinus unaryMinusClone;
		unaryMinusClone = new UnaryMinus();
		unaryMinusClone.expression = expression.cloneObject();
		return unaryMinusClone;
	}

/*	public BObject substitute(BIdentifier[] dest, Expression[] src) {
		UnaryMinus unaryMinus;
		Expression exp = (Expression) expression.substitute(dest, src);
		if (exp != expression) {
			unaryMinus = new UnaryMinus();
			unaryMinus.expression = exp;
			return unaryMinus;
		} else {
			return this;
		}
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG,
			BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb,
			String indent) {
		print.printFormat(this, sb, indent);
	}

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}
}