package zb2smt.bol;


public class While extends Substitution {
	Predicate condition;

	Substitution substitution;

	Predicate invariant;

	Expression variant;

	public While() {
	}
	
	public boolean isFree(BIdentifier[] idents){
		return condition.isFree(idents) && substitution.isFree(idents) 
		&& invariant.isFree(idents) && variant.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "WHILE ");
		condition.toBString(sb, indent);
		sb = sb.append(" DO\n");
		substitution.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "INVARIANT\n");
		invariant.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "VARIANT\n");
		variant.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "END");
	}*/

	/*public Predicate acceptPOGSubstitution(IPOGenerator pOG, Predicate inv) {
		return pOG.toSubstitute(inv, this);
	}*/
	
	public Predicate getCondition() {
		return condition;
	}

	public void setCondition(Predicate condition) {
		this.condition = condition;
	}

	public Predicate getInvariant() {
		return invariant;
	}

	public void setInvariant(Predicate invariant) {
		this.invariant = invariant;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}

	public Expression getVariant() {
		return variant;
	}

	public void setVariant(Expression variant) {
		this.variant = variant;
	}
}